/* /////////////////////////////////////////////////////////

          MILLIWATTMETRE  Arduino avec AD8307 
     ///Pour platine LCD/Boutons anciens modèle////  
//////////////////////////////////////////////////////////// 
 
 de 1 Khz à 500 MHz     -60 à + 13dbm
 
/////////////////////////////////////////////////////////////

 Version 2     mai 2013
 Version 2.01 aout 2014
 Version 2.02 aout 2015
 ---------------------
 
 La touche "select" permet la prise en compte d'un atténuateur monté devant la sonde.
 
 La Pin D13 bascule à 1 si la valeur de l'attenuateur est > 0
 ce qui permet une commutation automatique ou l'allumage d'une LED ...
 
 
 (Alain DEVAL) F5MNA  Site  http://f5mna.free.fr
 
////////////////////////////////////////////////////////////*/

#include <LiquidCrystal.h>
#include <math.h>
/*
 LCD RS pin to digital pin 8
 LCD Enable pin to digital pin 9
 LCD D4 pin to digital pin 4
 LCD D5 pin to digital pin 5
 LCD D6 pin to digital pin 6
 LCD D7 pin to digital pin 7
 LCD R/W pin to ground

 Enrée mesure issue de la sonde: Pin A1 (analogique)
 Commande de commutation d'attennuateur: Pin D13 avec résistance de tirage (entre 4.7 et 10 K) à la masse.
*/
int Param;
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);

// parametrage
int sensorValue = 0; // Pavé touches
int sensorPin = A0;
word val_key;
int Attenu; // Choix alternateur.
int AttPin = 13;

void setup()
{
  Serial.begin (9600);

  
  lcd.begin(16, 2); 
  delay (20);
  lcd.setCursor(1, 0);
  lcd.print ("Milliwattmetre");
  lcd.setCursor(0, 1);
  lcd.print("F5MNA  Version 2");
  delay(2000);
  lcd.clear();
  int Attenu = 0;
  int Param = 0;
  pinMode(AttPin, OUTPUT);   //pour éventuelle commutation automatique d'un attenuateur 
}

/////////////////////////////////////////////////  
     // MILLIWATTMETRE //
/////////////////////////////////////////////////  

void Parametres ()
{
 //lcd.clear(); 
 delay(100);
 switch (val_key) {
  case 9:  //touche UP
  if ((Attenu > -1) and (Attenu < 51)) {Attenu ++;} 
  if (Attenu > 50) {Attenu = 0;} 
   Serial.println ("High");
   Serial.println (Attenu);  
  break;
  
  case 25:  //touche down
  if (Attenu > 0) {Attenu -- ;} 
  Serial.println ("down");
  Serial.println (Attenu);    
  break;
  }
  lcd.setCursor (2,0);
  lcd.print ("Attenuateur   ");
  lcd.setCursor (3,1);
  lcd.print ("  ");
  lcd.print (Attenu);
  lcd.print (" dB      "); 
  
  if (Attenu == 0){ digitalWrite(AttPin, LOW);} //Commutation automatique d'un atténuateur 
  else
  {digitalWrite(AttPin, HIGH);}   

  delay (100);
}  


void Milliwatt (){  
  if (Param == 0)
  { 
  int pin1 = 1; // Pin A1 reliée à la sortie de la sonde
  float Tension = 0;
  float dBm1 = 0;  
  float Milliwat = 0;
  
  Tension = (  analogRead(pin1) * 5000.0) / 1023.0;
  dBm1 = (-84 +(Tension/25))+ Attenu;
  Milliwat = pow(10,(dBm1/10));  

     lcd.setCursor(4, 0);
     lcd.print (dBm1,1);
     lcd.print (" dBm  ");
     
     lcd.setCursor(4, 1);
         
     if ((dBm1 <= -10)and (dBm1 > -20)){
     lcd.print (Milliwat,3);
     lcd.print (" mW    ");} 
    
   
     if ((dBm1 <= -20)and (dBm1 > -50)){
     lcd.print (Milliwat*1000);
     lcd.print (" uW     ");} 
     
     if (dBm1 <= -50) {
     lcd.print (Milliwat*1000,3);
     lcd.print (" uW    ");} 
     
     else
     {
     lcd.print (Milliwat);
     lcd.print (" mW    "); }      
   } 
} 
   
  void loop (){
  
  sensorValue = analogRead(sensorPin); // lecture de la touche  
  val_key = int(sensorValue/10); // valeur entiere de la touche / 10
   Serial.println (val_key);
  
  if (val_key > 100) {Milliwatt();}
  if (val_key == 63) {
  (Param = Param + 1);
  delay (250);}
  
  if (Param == 1)
  {Parametres();}
  if (Param == 2){
  (Param = 0);
  lcd.clear();}
  }
